﻿using System;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using ff14bot;
using ff14bot.AClasses;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.NeoProfiles;
using ff14bot.Settings;
using Newtonsoft.Json;
using ff14bot.BotBases;
using System.Collections.Generic;
using System.Threading;
using System.Windows.Forms;
using ff14bot.Behavior;
using ff14bot.Navigation;
using TreeSharp;
using System.Linq;
 
namespace AnimusBook
{
    public class AnimusBook : BotPlugin
    {
        #region Globals


        public static string sPluginPath = "";
        public static string sBlankXML = "";
        public static byte BookID = 0;
        public static Dictionary<int, string> NetherfallI = new Dictionary<int, string>();
        public static Dictionary<int, string> NetherfireI = new Dictionary<int, string>();
        public static Dictionary<int, string> SkyearthI = new Dictionary<int, string>();
        public static Dictionary<int, string> SkyfallI = new Dictionary<int, string>();
        public static Dictionary<int, string> SkyfallII = new Dictionary<int, string>();
        public static Dictionary<int, string> SkyfireI = new Dictionary<int, string>();
        public static Dictionary<int, string> SkyfireII = new Dictionary<int, string>();
        public static Dictionary<int, string> SkywindI = new Dictionary<int, string>();
        public static Dictionary<int, string> SkywindII = new Dictionary<int, string>();
        public static Dictionary<string, uint> Fate = new Dictionary<string, uint>();
        public static Dictionary<uint, string> FateID = new Dictionary<uint, string>();
        public static Dictionary<string, string> FateLocation = new Dictionary<string, string>();
        public static Dictionary<byte, string> Books = new Dictionary<byte, string>();
        public static Dictionary<string, string> LeveNPC = new Dictionary<string, string>();
        public static Dictionary<int, string> FateKingJ = new Dictionary<int, string>();
        public static BookData Book;
        public static int iFateWaiting = -1;
        public static int iKillIndex = -1;
        private Composite _rootAnimus;

        #endregion

        #region Initialization

        public override string Author
        {
            get { return "Animus"; }
        }

        public override Version Version
        {
            get { return new Version(1, 7, 1); }
        }

        public override string Name
        {
            get { return "Animus Book HS"; }
        }


        public override void OnPulse()
        {

        }

        public override void OnInitialize()
        {

            #region AnimusBook
            sPluginPath = Path.Combine(GlobalSettings.Instance.PluginsPath, @"AnimusBook\Animus\");
            sBlankXML = Path.Combine(GlobalSettings.Instance.PluginsPath, @"AnimusBook\Blank.xml");
            Book = ZodiacManager.CurrentBook;
            BookID = Book.BookId;
            Common.LogText("Book Id - " + BookID.ToString());

            //Book Done
            NetherfallI.Add(1, "Southern Thanalan - Amalj'aa Brigands.xml");
            NetherfallI.Add(2, "South Shroud - Lesser Kalong.xml");
            NetherfallI.Add(3, "Mor Dhona - 5th Cohort Laquearius.xml");
            NetherfallI.Add(4, "Mor Dhona - Gigas Sozu.xml");
            NetherfallI.Add(5, "Coerthas - Snow Wolf.xml");
            NetherfallI.Add(6, "North Shroud - Ixali Windtalon.xml");
            NetherfallI.Add(7, "Outer La Noscea - U'Ghamaro Priest.xml");
            NetherfallI.Add(8, "Western Thanlan - 4th Cohort Secutor.xml");
            NetherfallI.Add(9, "East Shroud - Violet Screech.xml");
            NetherfallI.Add(10, "Western La Noscea - Sapsa Shelfclaws.xml");
            NetherfallI.Add(11, "Rude Awakening");
            NetherfallI.Add(12, "The Ceruleum Road");
            NetherfallI.Add(13, "The Four Winds");

            //Book Done
            SkywindII.Add(1, "Mor Dhona - Gigas Shramana.xml");
            SkywindII.Add(2, "Mor Dhona - 5th Cohort Signifier.xml");
            SkywindII.Add(3, "East Shroud- Dreamtoad.xml");
            SkywindII.Add(4, "North Shroud - Watchwolf.xml");
            SkywindII.Add(5, "Southern Thanalan - Amalj'aa Archer.xml");
            SkywindII.Add(6, "Western Thanalan - 4th Cohort Signifier.xml");
            SkywindII.Add(7, "Southern Thanalan - Zahar'ak Battle Drake.xml");
            SkywindII.Add(8, "Western La Noscea - Sapsa Shelftooth.xml");
            SkywindII.Add(9, "Coerthas - Natalan Fogcaller.xml");
            SkywindII.Add(10, "Outer La Noscea - Elite Priest.xml");
            SkywindII.Add(11, "Taken");
            SkywindII.Add(12, "Tower of Power");
            SkywindII.Add(13, "What Gored Before");

            //Book Done
            SkyfallI.Add(1, "Western La Noscea - Shelfscale Sahagin.xml");
            SkyfallI.Add(2, "Coerthas - Mudpuppy.xml");
            SkyfallI.Add(3, "Southern Thanalan - Amalj'aa Lancer.xml");
            SkyfallI.Add(4, "Mor Dhona - Lake Cobra.xml");
            SkyfallI.Add(5, "Coerthas - Giant Reader.xml");
            SkyfallI.Add(6, "Outer La Noscea - U'Ghamaro Quarryman.xml");
            SkyfallI.Add(7, "East Shroud - Sylphlands Sentinel.xml");
            SkyfallI.Add(8, "Western La Noscea - Sea Wasp.xml");
            SkyfallI.Add(9, "Northern Thanalan - Magitek Vanguard.xml");
            SkyfallI.Add(10, "Eastern La Noscea - 2nd Cohort Eques.xml");
            SkyfallI.Add(11, "Bellyfull");
            SkyfallI.Add(12, "The King's Justice");
            SkyfallI.Add(13, "Quartz Coupling");

            //Book Done
            SkyearthI.Add(1, "Southern Thanalan - Amalj'aa Scavenger.xml");
            SkyearthI.Add(2, "Mor Dhona - 5th Cohort Secutor.xml");
            SkyearthI.Add(3, "North Shroud - Ixali Boldwing.xml");
            SkyearthI.Add(4, "Southern Thanalan - Zahar'ak Pugilist.xml");
            SkyearthI.Add(5, "Western La Noscea - Axolotl.xml");
            SkyearthI.Add(6, "Mor Dhona - Hapalit.xml");
            SkyearthI.Add(7, "Outer La Noscea - Elite Quarryman.xml");
            SkyearthI.Add(8, "Coerthas - Natalan Swiftbeak.xml");
            SkyearthI.Add(9, "East Shroud - Violet Sigh.xml");
            SkyearthI.Add(10, "Eastern La Noscea - 2nd Cohort Signifier.xml");
            SkyearthI.Add(11, "The Taste of Fear");
            SkyearthI.Add(12, "Schism");
            SkyearthI.Add(13, "The Big Bagoly Theory");

            //Book Done
            SkyfallII.Add(1, "Southern Thanalan - Iron Tortoise.xml");
            SkyfallII.Add(2, "Mor Dhona - 5th Cohort Hoplomachus.xml");
            SkyfallII.Add(3, "South Shroud - Ked.xml");
            SkyfallII.Add(4, "Outer La Noscea - U'Ghamaro Bedesman.xml");
            SkyfallII.Add(5, "Western La Noscea - Shelfeye Reaver.xml");
            SkyfallII.Add(6, "Western Thanlan - 4th Cohort Laquearus.xml");
            SkyfallII.Add(7, "East Shroud - Sylph Bonnet.xml");
            SkyfallII.Add(8, "Coerthas - Natalan Watchwolf.xml");
            SkyfallII.Add(9, "Mor Dhona - Gigas Bhikkhu.xml");
            SkyfallII.Add(10, "Western La Noscea - Sapsa Shelfscales.xml");
            SkyfallII.Add(11, "Breaching North Tidegate");
            SkyfallII.Add(12, "Black and Nburu");
            SkyfallII.Add(13, "Breaking Dawn");

            //Book Done
            NetherfireI.Add(1, "South Shroud - Wild Hog.xml");
            NetherfireI.Add(2, "Mor Dhona - Hexing Harrier.xml");
            NetherfireI.Add(3, "East Shroud- Sylpheed Screech.xml");
            NetherfireI.Add(4, "Coerthas - Giant Lugger.xml");
            NetherfireI.Add(5, "Southern Thanalan - Tempered Orator.xml");
            NetherfireI.Add(6, "Mor Dhona - Gigas Bonze.xml");
            NetherfireI.Add(7, "Outer La Noscea - U'Ghamaro Roundsman.xml");
            NetherfireI.Add(8, "Western La Noscea - Shelfclaw Reaver.xml");                        
            NetherfireI.Add(9, "Southern Thanalan - Zahar'ak Fortuneteller.xml");
            NetherfireI.Add(10, "Eastern La Noscea - 2nd Cohort Laquearii.xml");
            //Verify Fates
            NetherfireI.Add(11, "Another Notch on the Torch");
            NetherfireI.Add(12, "Everything's Better");
            NetherfireI.Add(13, "Return to Cinder");

            //Book Done
            SkyfireII.Add(1, "Mor Dhona - Raging Harrier.xml");
            SkyfireII.Add(2, "East Shroud- Sylpheed Sigh.xml");
            SkyfireII.Add(3, "Coerthas - Biast.xml");
            SkyfireII.Add(4, "Western La Noscea - Shoaltooth Sahagin.xml");
            SkyfireII.Add(5, "Southern Thanalan - Tempered Gladiator.xml");
            SkyfireII.Add(6, "North Shroud - Dullahan.xml");
            SkyfireII.Add(7, "Western La Noscea - Shelfscale Reaver.xml");
            SkyfireII.Add(8, "Southern Thanalan - Zahar'ak Archer.xml");
            SkyfireII.Add(9, "Outer La Noscea - U'Ghamaro Golem.xml");
            SkyfireII.Add(10, "Coerthas - Natalan Boldwing.xml");
            SkyfireII.Add(11, "Breaching South Tidegate");
            SkyfireII.Add(12, "Heroes of the 2nd");
            SkyfireII.Add(13, "Air Supply");

            //Book Done
            SkywindI.Add(1, "East Shroud - Sylpheed Snarls.xml");
            SkywindI.Add(2, "SouthernThanalan - Amaljaa Thm.xml");
            SkywindI.Add(3, "Mor Dhona - 5th Cohort Eques.xml");
            SkywindI.Add(4, "Western La Noscea - Sapsa Elbst.xml");
            SkywindI.Add(5, "Mor Dhona - Hippogryph.xml");
            SkywindI.Add(6, "Western La Noscea - Trenchtooth Sahagin.xml");
            SkywindI.Add(7, "Coerthas - Natalan Windtalon.xml");
            SkywindI.Add(8, "Outer La Noscea - Elite Roundsman.xml");
            SkywindI.Add(9, "Northern Thanalan - Ahriman.xml");
            SkywindI.Add(10, "Eastern La Noscea - 2nd Cohort Secutores.xml");
            SkywindI.Add(11, "Surprise");
            SkywindI.Add(12, "In Spite of It All");
            SkywindI.Add(13, "Good to Be Bud");

            //Book Done
            SkyfireI.Add(1, "Mor Dhona - Daring Harrier.xml");
            SkyfireI.Add(2, "Coerthas - Giant Logger.xml");
            SkyfireI.Add(3, "Western La Noscea - Shoalspine Sahagin.xml");
            SkyfireI.Add(4, "Mor Dhona - 5th Cohort Vanguard.xml");
            SkyfireI.Add(5, "Outer La Noscea - Synthetic Doblyn.xml");
            SkyfireI.Add(6, "Western Thanlan - 4th Cohort Hoplomachi.xml");
            SkyfireI.Add(7, "Southern Thanalan - Zanr'ak Pugilist.xml");
            SkyfireI.Add(8, "East Shroud - Milkroot Cluster.xml");
            SkyfireI.Add(9, "Northern Thanalan - Basilisk.xml");
            SkyfireI.Add(10, "Eastern La Noscea - 2nd Cohort Hoplomachi.xml");
            SkyfireI.Add(11, "Giant Seps");
            SkyfireI.Add(12, "Make It Rain");
            SkyfireI.Add(13, "The Enmity of My Enemy");

            Books.Add(1, "Skyfire I");
            Books.Add(2, "Skyfire II");
            Books.Add(3, "Netherfire I");
            Books.Add(4, "Skyfall I");
            Books.Add(5, "Skyfall II");//Maybe
            Books.Add(6, "Netherfall I");
            Books.Add(7, "Skywind I");//Maybe
            Books.Add(8, "Skywind II");
            Books.Add(9, "Skyearth I");


            Fate.Add("Taken", 20);//ForgottenSprings
            Fate.Add("Tower of Power", 23);//Dragonhead
            Fate.Add("What Gored Before", 5);//Quarymill
            Fate.Add("Rude Awakening", 7); //Fallguard
            Fate.Add("The Ceruleum Road", 22); //Cellrum Processing Plant
            Fate.Add("The Four Winds", 23);//Dragonhead
            Fate.Add("Another Notch on the Torch", 24); //RevertentsToll
            Fate.Add("Everything's Better", 4); //HawthorneHut
            Fate.Add("Return to Cinder", 20);//ForgottenSprings
            Fate.Add("The Taste of Fear", 23);//Dragonhead
            Fate.Add("The Big Bagoly Theory", 18);//Drybone
            Fate.Add("Schism", 16);//CampOverlook
            Fate.Add("Bellyfull", 23);//Dragonhead
            Fate.Add("The King's Justice", 14);//Aleport
            Fate.Add("Quartz Coupling", 18);//Drybone
            Fate.Add("Black and Nburu", 24);  //RevertentsToll
            Fate.Add("Breaching North Tidegate", 14);//Aleport  //Add Custom Logic to finish "Gauging North Tidegate"
            Fate.Add("Breaking Dawn", 4); //HawthorneHut
            Fate.Add("Giant Seps", 23);//Dragonhead
            Fate.Add("Make It Rain", 16);//CampOverlook
            Fate.Add("The Enmity of My Enemy", 4); //HawthorneHut
            Fate.Add("Heroes of the 2nd", 20);//ForgottenSprings
            Fate.Add("Breaching South Tidegate", 14);//Aleport  //Add Custom Logic to finish "Gauging South Tidegate"
            Fate.Add("Air Supply", 7); //Fallguard
            Fate.Add("Surprise", 15);//CampBronzeLake
            Fate.Add("In Spite of It All", 3);//BentbranchMedows
            Fate.Add("Good to Be Bud", 24); //RevertentsToll
            Fate.Add("The Enemy of My Enemy", 4);
            Fate.Add("Gauging North Tidegate", 14);
            Fate.Add("Gauging South Tidegate", 14);

            //FateID.Add(552,"Taken");
            //FateID.Add(486, "Tower of Power");
            //FateID.Add(628, "What Gored Before");
            //FateID.Add(632, "Rude Awakening"); 
            //FateID.Add(642, "The Ceruleum Road");
            //FateID.Add(499, "The Four Winds");
            //FateID.Add(521, "Another Notch on the Torch");
            //FateID.Add(620, "Everything's Better");
            //FateID.Add(430, "Return to Cinder");
            //FateID.Add(493, "The Taste of Fear");
            //FateID.Add(543, "The Big Bagoly Theory");
            //FateID.Add(587, "Schism");
            //FateID.Add(475, "Bellyfull");
            //FateID.Add(577, "The King's Justice");
            //FateID.Add(540, "Quartz Coupling");
            //FateID.Add(516, "Black and Nburu");
            //FateID.Add(569, "Breaching North Tidegate");
            //FateID.Add(616, "Breaking Dawn");
            //FateID.Add(480, "Giant Seps");
            //FateID.Add(589, "Make It Rain");
            //FateID.Add(611, "The Enmity of My Enemy");
            //FateID.Add(424, "Heroes of the 2nd");
            //FateID.Add(571, "Breaching South Tidegate");
            //FateID.Add(633, "Air Supply");
            //FateID.Add(317, "Surprise");
            //FateID.Add(604, "In Spite of It All");
            //FateID.Add(517, "Good to Be Bud");
            //FateID.Add(610, "The Enemy of My Enemy");
            //FateID.Add(568, "Gauging North Tidegate");
            //FateID.Add(570, "Gauging South Tidegate"); 

            FateLocation.Add("Taken", "-179.6152, 6.204385, -124.7025");
            FateLocation.Add("Tower of Power", "-510.7703, 238.454, 375.3579");
            FateLocation.Add("What Gored Before", "360.4008, -2.775533, 71.26025");
            FateLocation.Add("Rude Awakening", "49.70298, -12.96013, -9.467698");
            FateLocation.Add("The Ceruleum Road", "28.28433, 4.204345, 387.5942");
            FateLocation.Add("The Four Winds", "618.7935, 299.8786, -42.3924");
            FateLocation.Add("Another Notch on the Torch", "398.0729, -8.347237, -728.0207");
            FateLocation.Add("Everything's Better", "136.1643, -25.27018, -374.4165");
            FateLocation.Add("Return to Cinder", "126.9029, 9.485744, 256.9145");
            FateLocation.Add("The Taste of Fear", "-792.3039, 226.3146, 49.79809");
            FateLocation.Add("The Big Bagoly Theory", "467.9727, -63.22946, 246.4327");
            FateLocation.Add("Schism", "119.3676, 74.57643, -246.7937");
            FateLocation.Add("Bellyfull", "645.9232, 321.962, -392.5724");
            FateLocation.Add("The King's Justice", "");
            FateLocation.Add("Quartz Coupling", "189.3806, -16.53403, 161.3464");
            FateLocation.Add("Black and Nburu", "-328.2501, -17.14841, -365.6849");
            FateLocation.Add("Breaching North Tidegate", "-46.79461, -22.98182, -103.7344");
            FateLocation.Add("Breaking Dawn", "471.5446, -16.04326, -312.61952");
            FateLocation.Add("Giant Seps", "-624.3624, 204.3567, -461.2679");
            FateLocation.Add("Make It Rain", "180.4814, 60.284, -151.015");
            FateLocation.Add("The Enmity of My Enemy", "313.9022, -6.886113, -9.843127");
            FateLocation.Add("Heroes of the 2nd", "-19.20385, -0.01800346, -243.3136");
            FateLocation.Add("Breaching South Tidegate", "-125.8132, -24.12006, 53.07963");
            FateLocation.Add("Air Supply", "10.67856, -13.60869, -16.32302");
            FateLocation.Add("Surprise", "296.8803, 19.31517, -89.71117");
            FateLocation.Add("In Spite of It All", "-522.5546, 20.04927, -163.4851");
            FateLocation.Add("Good to Be Bud", "-406.0211, -16.92065, -483.0523");
            FateLocation.Add("The Enemy of My Enemy", "");
            FateLocation.Add("Gauging North Tidegate", "-46.79461, -22.98182, -103.7344");
            FateLocation.Add("Gauging South Tidegate", "-125.8132, -24.12006, 53.07963");

            LeveNPC.Add("RevToll-Leve", "416.3794, -6.021661, -446.2992");
            LeveNPC.Add("RevToll-GCLeve", "463.0505, -4.160048, -466.1066");
            LeveNPC.Add("Dragon-Leve", "-440.4061, 211, -234.0763");
            LeveNPC.Add("Dragon-GCLeve", "-474.9649, 211, -233.7088");
            LeveNPC.Add("BlueFrog-Level", "34.71375, 4.873114, 397.5457");

            #endregion

        }

        public override void OnShutdown()
        {
            TreeHooks.Instance.OnHooksCleared -= OnHooksCleared;
            RemoveHook();

        }

        public override void OnEnabled()
        {
            TreeHooks.Instance.OnHooksCleared += OnHooksCleared;
            //_rootAnimus = new ActionRunCoroutine(r => CoreBook.TestFateHook());
            _rootAnimus = new ActionRunCoroutine(r => CoreBook.StartAnimusBook());
        }

        public override void OnDisabled()
        {
            TreeHooks.Instance.OnHooksCleared -= OnHooksCleared;
            RemoveHook();
        }
        #endregion

        #region Hooks
        private void OnHooksCleared(object sender, EventArgs args)
        {
            iFateWaiting = -1;
            iKillIndex = -1;
            AddHook();
        }

        public void AddHook()
        {
            TreeHooks.Instance.AddHook("TreeStart", _rootAnimus);
            Common.LogText("Loading Profile - Blank");
            NeoProfileManager.Load(sBlankXML, true);
            CoreBook.CleanupGlobalsforFate();
        }

        public void RemoveHook()
        {
            TreeHooks.Instance.RemoveHook("TreeStart", _rootAnimus);
            CoreBook.ClearFate();
        }

        #endregion
    }
}

