﻿using System.Diagnostics;
using System.Threading;
using System.Threading.Tasks;
using Buddy.Coroutines;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using Clio.Utilities;
using ff14bot.RemoteWindows;
using ff14bot.NeoProfiles;
using ff14bot.BotBases;
using ff14bot.Enums;
using ff14bot.Objects;

namespace AnimusBook
{
    class Movement
    {

        private const int MAX_TICKS = 100;
        private const int WAIT_TIME = 200;
        private const int MOVE_TIMEOUT_MS = 900000;


        public static async Task<bool> Teleport(uint TeleportID)
        {
            Common.LogText("Teleporting to - " + TeleportID.ToString());
            WorldManager.TeleportById(TeleportID);
            await Coroutine.Sleep(15000);
            return true;
        }

        public static async Task<bool> MoveTo(Vector3 location)
        {
            var stopwatch = new Stopwatch();
            stopwatch.Start();
            while (stopwatch.ElapsedMilliseconds < MOVE_TIMEOUT_MS && Core.Me.IsAlive)
            {
                if (Navigator.NavigationProvider != null) { Navigator.MoveTo(location); }
                else { break; }

                float distance = Core.Me.Location.Distance(location);
                if (distance < 0.8f)
                {
                    stopwatch.Stop();
                    Navigator.Stop();
                    return true;
                }

                if (Core.Me.IsMounted && distance < 20f) { await Common.Dismount(); }
                else { await Coroutine.Yield(); }
            }

            Navigator.Stop();
            stopwatch.Stop();
            return false;
        }
    }
}
